# Module cargo::core::source::source_id

source ·

## Structs

- PrettyRef
  A git reference that can be `Display`ed
- SourceId
  Unique identifier for a source of packages.
- SourceIdAsUrl
  A `Display`able view into a `SourceId` that will write it as a url
- SourceIdInner 🔒
  The interned version of `SourceId` to avoid excessive clones and borrows. Values are cached in `SOURCE_ID_CACHE` once created.

## Enums

- GitReference
  Information to find a specific commit in a Git repository.
- SourceKind 🔒
  The possible kinds of code source. Along with `SourceIdInner`, this fully defines the source.

## Statics

- SOURCE_ID_CACHE 🔒

## Functions

- is_overridden_crates_io_url 🔒
  Check if `url` equals to the overridden crates.io URL.
- url_display 🔒